"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _objectSpread = require("@babel/runtime/helpers/objectSpread2"), _defineProperty = require("@babel/runtime/helpers/defineProperty"), core = require("@remirror/core"), _createForOfIteratorHelper = require("@babel/runtime/helpers/createForOfIteratorHelper"), _classPrivateFieldGet = require("@babel/runtime/helpers/classPrivateFieldGet"), _classPrivateFieldSet = require("@babel/runtime/helpers/classPrivateFieldSet"), CodeMirror = require("codemirror"), commands = require("@remirror/pm/commands"), history = require("@remirror/pm/history"), state = require("@remirror/pm/state");

function _interopDefault(e) {
  return e && e.__esModule ? e : {
    default: e
  };
}

require("codemirror/mode/meta");

var _objectSpread__default = _interopDefault(_objectSpread), _defineProperty__default = _interopDefault(_defineProperty), _createForOfIteratorHelper__default = _interopDefault(_createForOfIteratorHelper), _classPrivateFieldGet__default = _interopDefault(_classPrivateFieldGet), _classPrivateFieldSet__default = _interopDefault(_classPrivateFieldSet), CodeMirror__default = _interopDefault(CodeMirror);

function arrowHandler(dir) {
  return _ref => {
    var dispatch = _ref.dispatch, view = _ref.view, tr = _ref.tr;
    if (!view) return !1;
    if (!tr.selection.empty || !view.endOfTextblock(dir)) return !1;
    var side = "left" === dir || "up" === dir ? -1 : 1, $head = tr.selection.$head, nextPos = state.Selection.near(tr.doc.resolve(side > 0 ? $head.after() : $head.before()), side);
    return !(!nextPos.$head || "codeMirror" !== nextPos.$head.parent.type.name) && (null == dispatch || dispatch(tr.setSelection(nextPos)), 
    !0);
  };
}

function updateNodeAttributes(type) {
  return attributes => _ref2 => {
    var _ref2$state = _ref2.state, tr = _ref2$state.tr, selection = _ref2$state.selection, dispatch = _ref2.dispatch, parent = core.findParentNodeOfType({
      types: type,
      selection: selection
    });
    return !(!parent || core.isEqual(attributes, parent.node.attrs)) && (tr.setNodeMarkup(parent.pos, type, _objectSpread__default.default(_objectSpread__default.default({}, parent.node.attrs), attributes)), 
    dispatch && dispatch(tr), !0);
  };
}

function parseLanguageToMode(language) {
  if (language) {
    var mime = CodeMirror__default.default.findModeByName(language);
    return null == mime ? void 0 : mime.mode;
  }
  return null;
}

var _dec, _class, _temp, _node = new WeakMap, _cm = new WeakMap, _schema = new WeakMap, _view = new WeakMap, _getPos = new WeakMap, _incomingChanges = new WeakMap, _updating = new WeakMap;

class CodeMirrorNodeView {
  constructor(node, view, getPos, config) {
    _node.set(this, {
      writable: !0,
      value: void 0
    }), _cm.set(this, {
      writable: !0,
      value: void 0
    }), _schema.set(this, {
      writable: !0,
      value: void 0
    }), _view.set(this, {
      writable: !0,
      value: void 0
    }), _getPos.set(this, {
      writable: !0,
      value: void 0
    }), _incomingChanges.set(this, {
      writable: !0,
      value: !1
    }), _updating.set(this, {
      writable: !0,
      value: !1
    }), _classPrivateFieldSet__default.default(this, _node, node), _classPrivateFieldSet__default.default(this, _schema, node.type.schema), 
    _classPrivateFieldSet__default.default(this, _view, view), _classPrivateFieldSet__default.default(this, _getPos, getPos), 
    _classPrivateFieldSet__default.default(this, _cm, CodeMirror__default.default(null, _objectSpread__default.default({
      value: _classPrivateFieldGet__default.default(this, _node).textContent,
      extraKeys: this.codeMirrorKeymap()
    }, config))), this.dom = _classPrivateFieldGet__default.default(this, _cm).getWrapperElement(), 
    this.setupCodeMirrorHandlers();
  }
  setupCodeMirrorHandlers() {
    setTimeout((() => _classPrivateFieldGet__default.default(this, _cm).refresh()), 20), 
    _classPrivateFieldSet__default.default(this, _updating, !1), _classPrivateFieldGet__default.default(this, _cm).on("beforeChange", (() => _classPrivateFieldSet__default.default(this, _incomingChanges, !0))), 
    _classPrivateFieldGet__default.default(this, _cm).on("cursorActivity", (() => {
      _classPrivateFieldGet__default.default(this, _updating) || _classPrivateFieldGet__default.default(this, _incomingChanges) || this.forwardSelection();
    })), _classPrivateFieldGet__default.default(this, _cm).on("changes", (() => {
      _classPrivateFieldGet__default.default(this, _updating) || (this.valueChanged(), 
      this.forwardSelection()), _classPrivateFieldSet__default.default(this, _incomingChanges, !1);
    })), _classPrivateFieldGet__default.default(this, _cm).on("focus", (() => this.forwardSelection()));
  }
  forwardSelection() {
    if (_classPrivateFieldGet__default.default(this, _cm).hasFocus()) {
      var state = _classPrivateFieldGet__default.default(this, _view).state, selection = this.asProseMirrorSelection(state.doc);
      selection.eq(state.selection) || _classPrivateFieldGet__default.default(this, _view).dispatch(state.tr.setSelection(selection));
    }
  }
  asProseMirrorSelection(doc) {
    var offset = _classPrivateFieldGet__default.default(this, _getPos).call(this) + 1, anchor = _classPrivateFieldGet__default.default(this, _cm).indexFromPos(_classPrivateFieldGet__default.default(this, _cm).getCursor("anchor")) + offset, head = _classPrivateFieldGet__default.default(this, _cm).indexFromPos(_classPrivateFieldGet__default.default(this, _cm).getCursor("head")) + offset;
    return state.TextSelection.create(doc, anchor, head);
  }
  setSelection(anchor, head) {
    _classPrivateFieldGet__default.default(this, _cm).focus(), _classPrivateFieldSet__default.default(this, _updating, !0), 
    _classPrivateFieldGet__default.default(this, _cm).setSelection(_classPrivateFieldGet__default.default(this, _cm).posFromIndex(anchor), _classPrivateFieldGet__default.default(this, _cm).posFromIndex(head)), 
    _classPrivateFieldSet__default.default(this, _updating, !1);
  }
  valueChanged() {
    var change = computeTextChange(_classPrivateFieldGet__default.default(this, _node).textContent, _classPrivateFieldGet__default.default(this, _cm).getValue());
    if (change) {
      var start = _classPrivateFieldGet__default.default(this, _getPos).call(this) + 1, tr = _classPrivateFieldGet__default.default(this, _view).state.tr.replaceWith(start + change.from, start + change.to, change.text ? _classPrivateFieldGet__default.default(this, _schema).text(change.text) : []);
      _classPrivateFieldGet__default.default(this, _view).dispatch(tr);
    }
  }
  codeMirrorKeymap() {
    var view = _classPrivateFieldGet__default.default(this, _view), mod = /Mac/.test(navigator.platform) ? "Cmd" : "Ctrl";
    return CodeMirror__default.default.normalizeKeyMap({
      Up: () => this.maybeEscape("line", -1),
      Left: () => this.maybeEscape("char", -1),
      Down: () => this.maybeEscape("line", 1),
      Right: () => this.maybeEscape("char", 1),
      "Ctrl-Enter": () => {
        commands.exitCode(view.state, view.dispatch) && view.focus();
      },
      ["".concat(mod, "-Z")]: () => history.undo(view.state, view.dispatch),
      ["Shift-".concat(mod, "-Z")]: () => history.redo(view.state, view.dispatch),
      ["".concat(mod, "-Y")]: () => history.redo(view.state, view.dispatch)
    });
  }
  maybeEscape(unit, dir) {
    var pos = _classPrivateFieldGet__default.default(this, _cm).getCursor();
    if (_classPrivateFieldGet__default.default(this, _cm).somethingSelected() || pos.line !== (dir < 0 ? _classPrivateFieldGet__default.default(this, _cm).firstLine() : _classPrivateFieldGet__default.default(this, _cm).lastLine()) || "char" === unit && pos.ch !== (dir < 0 ? 0 : _classPrivateFieldGet__default.default(this, _cm).getLine(pos.line).length)) return CodeMirror__default.default.Pass;
    _classPrivateFieldGet__default.default(this, _view).focus();
    var targetPos = _classPrivateFieldGet__default.default(this, _getPos).call(this) + (dir < 0 ? 0 : _classPrivateFieldGet__default.default(this, _node).nodeSize), selection = state.Selection.near(_classPrivateFieldGet__default.default(this, _view).state.doc.resolve(targetPos), dir);
    return _classPrivateFieldGet__default.default(this, _view).dispatch(_classPrivateFieldGet__default.default(this, _view).state.tr.setSelection(selection).scrollIntoView()), 
    _classPrivateFieldGet__default.default(this, _view).focus(), null;
  }
  update(node) {
    if (node.type !== _classPrivateFieldGet__default.default(this, _node).type) return !1;
    var textChange = computeTextChange(_classPrivateFieldGet__default.default(this, _cm).getValue(), node.textContent), attrsChange = computeAttrsChange(_classPrivateFieldGet__default.default(this, _node).attrs, node.attrs);
    if (_classPrivateFieldSet__default.default(this, _node, node), textChange || attrsChange) {
      if (_classPrivateFieldSet__default.default(this, _updating, !0), textChange && _classPrivateFieldGet__default.default(this, _cm).replaceRange(textChange.text, _classPrivateFieldGet__default.default(this, _cm).posFromIndex(textChange.from), _classPrivateFieldGet__default.default(this, _cm).posFromIndex(textChange.to)), 
      attrsChange) {
        var _step, _iterator = _createForOfIteratorHelper__default.default(Object.keys(attrsChange));
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done; ) {
            var k = _step.value;
            _classPrivateFieldGet__default.default(this, _cm).setOption(k, attrsChange[k]);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
      _classPrivateFieldSet__default.default(this, _updating, !1);
    }
    return !0;
  }
  selectNode() {
    _classPrivateFieldGet__default.default(this, _cm).focus();
  }
  stopEvent() {
    return !0;
  }
}

function computeTextChange(previousText, currentText) {
  if (previousText === currentText) return null;
  for (var from = 0, to = previousText.length, currentTo = currentText.length; from < to && previousText.charCodeAt(from) === currentText.charCodeAt(from); ) ++from;
  for (;to > from && currentTo > from && previousText.charCodeAt(to - 1) === currentText.charCodeAt(currentTo - 1); ) to--, 
  currentTo--;
  return {
    from: from,
    to: to,
    text: currentText.slice(from, currentTo)
  };
}

function computeAttrsChange(oldAttrs, newAttrs) {
  var _oldAttrs$codeMirrorC, _newAttrs$codeMirrorC, _step2, updated = !1, deltaConfig = {}, oldConfig = null !== (_oldAttrs$codeMirrorC = oldAttrs.codeMirrorConfig) && void 0 !== _oldAttrs$codeMirrorC ? _oldAttrs$codeMirrorC : {}, newConfig = null !== (_newAttrs$codeMirrorC = newAttrs.codeMirrorConfig) && void 0 !== _newAttrs$codeMirrorC ? _newAttrs$codeMirrorC : {}, _iterator2 = _createForOfIteratorHelper__default.default(Object.keys(oldConfig));
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
      var key = _step2.value;
      oldConfig[key] !== newConfig[key] && (deltaConfig[key] = newConfig[key], updated = !0);
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return oldAttrs.language !== newAttrs.language && (deltaConfig.mode = parseLanguageToMode(newAttrs.language), 
  updated = !0), updated ? deltaConfig : null;
}

var CodeMirrorExtension = (_dec = core.extensionDecorator({
  defaultOptions: {
    defaultCodeMirrorConfig: null
  }
}))(_class = _temp = class extends core.NodeExtension {
  constructor() {
    super(...arguments), _defineProperty__default.default(this, "tags", [ core.ExtensionTag.BlockNode, core.ExtensionTag.Code ]);
  }
  get name() {
    return "codeMirror";
  }
  createNodeSpec(extra) {
    return {
      group: "block",
      content: "text*",
      marks: "",
      code: !0,
      defining: !0,
      attrs: _objectSpread__default.default(_objectSpread__default.default({}, extra.defaults()), {}, {
        codeMirrorConfig: {
          default: void 0
        },
        language: {
          default: void 0
        }
      }),
      parseDOM: [ {
        tag: "pre",
        getAttrs: node => !!core.isElementDomNode(node) && extra.parse(node)
      } ],
      toDOM: () => [ "pre", [ "code", 0 ] ],
      isolating: !0
    };
  }
  createNodeViews() {
    return (node, view, getPos) => {
      var codeMirrorConfig = _objectSpread__default.default(_objectSpread__default.default({}, this.options.defaultCodeMirrorConfig), node.attrs.codeMirrorConfig);
      if (node.attrs.language) {
        var mode = parseLanguageToMode(node.attrs.language);
        mode && (codeMirrorConfig.mode = mode);
      }
      return new CodeMirrorNodeView(node, view, getPos, codeMirrorConfig);
    };
  }
  createKeymap() {
    return {
      ArrowLeft: arrowHandler("left"),
      ArrowRight: arrowHandler("right"),
      ArrowUp: arrowHandler("up"),
      ArrowDown: arrowHandler("down")
    };
  }
  createCommands() {
    return {
      createCodeMirror: attributes => core.setBlockType(this.type, attributes),
      updateCodeMirror: attributes => updateNodeAttributes(this.type)(attributes)
    };
  }
}) || _class;

exports.CodeMirrorExtension = CodeMirrorExtension;
